/* An hlguard command plugin - Version 0.1
 *
 *
 * Name: plugin_DOD_restart
 * Author: Stillsetzhut (stillsetzhut@thh-clan.de)
 * Released: 08/11/03
 *
 *
 * Version 0.1
 *
 *
 * Enable restartround for Day of Defeath
 *
 *
 */

#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

#define ACCESS_STILLS 256;
#define ACCESS_VOTES 128;
new STRING_VERSION[MAX_DATA_LENGTH] = "0.1";

public admin_restartround(HLCommand,HLData,HLUserName,UserIndex){
    new Command[MAX_COMMAND_LENGTH];
    new Data[MAX_DATA_LENGTH];
    new User[MAX_NAME_LENGTH];
    convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
    convert_string(HLData,Data,MAX_DATA_LENGTH);
    convert_string(HLUserName,User,MAX_NAME_LENGTH);
    execute_command(User,Command,"restartround",Data);
    return PLUGIN_HANDLED;
}

public admin_vote_restart(HLCommand,HLData,HLUserName,UserIndex){
    new ratio = getvar("map_ratio");
    if(!ratio){
        say("Restart vote is not enabled");
    } else if(!vote_allowed()) {
        selfmessage( "Vote not allowed at this time.");
    } else {
        vote("Restart map & begin play?","Yes","No","HandleRestartVote","");
    }
    return PLUGIN_HANDLED;
}

public HandleRestartVote(WinningOption,HLUser,VoteCount,UserCount){
    if(WinningOption == 1 ){
        new ratio = getvar("map_ratio");
        if(VoteCount < (ratio/100)*UserCount){
            say("Not enough votes for map restart");
        } else {
            new Timelimit[MAX_NUMBER_LENGTH];
            numtostr((getvar("mp_timelimit") * 60 - timeleft() + 10) / 60,Timelimit);
            setstrvar("mp_timelimit",Timelimit);
            setstrvar("restartround","10");
            say("Map restart vote succeeded.");
        }
    } else {
        say("Map restart vote failed.");
    }
}

public plugin_init(){
	plugin_registerinfo("A DoD additional Plugin","Enable restartround for the Mod DoD",STRING_VERSION);
	plugin_registercmd("admin_vote_restart","admin_vote_restart",ACCESS_VOTES,"admin_vote_restart: Starts a vote to restart the round.");
    	plugin_registercmd("admin_restartround","admin_restartround",ACCESS_STILLS,"admin_restartround <seconds>: Restarts the round.");
}